#ifndef VGA_H
#define VGA_H 1

#include <stdint.h>

typedef enum _vga_color {
	VGA_BLACK,
	VGA_BLUE,
	VGA_GREEN,
	VGA_CYAN,
	VGA_RED,
	VGA_MAGENTA,
	VGA_BROWN,
	VGA_LIGHT_GREY,
	VGA_DARK_GREY,
	VGA_LIGHT_BLUE,
	VGA_LIGHT_GREEN,
	VGA_LIGHT_CYAN,
	VGA_LIGHT_RED,
	VGA_LIGHT_MAGENTA,
	VGA_LIGHT_BROWN,
	VGA_WHITE
} vga_color;
typedef uint8_t display_color;
typedef uint16_t display;

static inline display_color vga_entry_color(vga_color fg, vga_color bg)
{
	return fg | bg << 4;
}

static inline display vga_entry(unsigned char c, display_color color)
{
	return (display)c | (display)color << 8;
}

#endif //VGA_H
