#include "ps2_layout.h"

#include <kernel/keyboard.h>

/*
On ne fait que le scan code 1.

On occupe jusqu'à 0x7F avec les codes qui fonctionnent 'seuls', le dernier
étant F12 (0x58), puis on complète avec ceux qui succèdent à 0xE0.
Tout code c originellement au dessus de 0x80 est normalement la version
"release" de c - 0x80.
*/

char ps2_scset1_qwerty[256] = {
	0,		'\e',	'1',	'2',	'3',	'4',	'5',	'6',
	'7',	'8',	'9',	'0',	'-',	'=',	'\b',	'\t',
	'q',	'w',	'e',	'r',	't',	'y',	'u',	'i',
	'o',	'p',	'[',	']',	'\n',	0,		'a',	's',
	'd',	'f',	'g',	'h',	'j',	'k',	'l',	';',
	'\'',	'`',	0,		'\\',	'z',	'x',	'c',	'v',
	'b',	'n',	'm',	',',	'.',	'/',	0,		'*',
	0,		' ',	0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		'7',
	'8',	'9',	'-',	'4',	'5',	'6',	'+',	'1',
	'2',	'3',	'0',	'.',	0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		'\n',	0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		'/',	0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		HOME,
	UP,		PGUP,	0,		LEFT,	0,		RIGHT,	0,		END,
	DOWN,	PGDOWN,	0,		0x7F,	0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0
};

char ps2_scset1_qwerty_maj[256] = {
	0,		'\e',	'!',	'@',	'#',	'$',	'%',	'^',
	'&',	'*',	'(',	')',	'_',	'+',	'\b',	'\t',
	'Q',	'W',	'E',	'R',	'T',	'Y',	'U',	'I',
	'O',	'P',	'{',	'}',	'\n',	0,		'A',	'S',
	'D',	'F',	'G',	'H',	'J',	'K',	'L',	':',
	'"',	'~',	0,		'|',	'Z',	'X',	'C',	'V',
	'B',	'N',	'M',	'<',	'>',	'?',	0,		'*',
	0,		' ',	0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		'7',
	'8',	'9',	'-',	'4',	'5',	'6',	'+',	'1',
	'2',	'3',	'0',	'.',	0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		'\n',	0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		'/',	0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		HOME,
	UP,		PGUP,	0,		LEFT,	0,		RIGHT,	0,		END,
	DOWN,	PGDOWN,	0,		0x7F,	0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0
};

ps2_layout ps2_layouts_available[N_LAYOUTS] = {
	{ "QWERTY", { ps2_scset1_qwerty, ps2_scset1_qwerty_maj }, 0 }
};
