#ifndef INTERRUPT_H
#define INTERRUPT_H 1

#include <stdbool.h>

typedef enum _int_number
{
	PIT_INT = 0x20,
	KBD_INT
} int_number;

typedef struct _interrupt_frame interrupt_frame;

void send_EOI(unsigned char irq);
//Les deux fonctions suivantes renvoient vrai si l'IRQ doit être ignoré
bool handle_spurious_7();
bool handle_spurious_15();

void set_interrupt(int n_int, void (*isr)(interrupt_frame *));

#endif //INTERRUPT_H
